<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcNewCamera Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcNewCamera Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcNewCamera" --><!-- doxytag: inherits="iPcCamera" -->
<p>This is a camera property class.  
 <a href="structiPcNewCamera.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="newcamera_8h_source.html">propclass/newcamera.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcNewCamera:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcNewCamera.png" usemap="#iPcNewCamera_map" alt=""/>
  <map id="iPcNewCamera_map" name="iPcNewCamera_map">
<area href="structiPcCamera.html" title="The representation of a camera." alt="iPcCamera" shape="rect" coords="0,56,99,80"/>
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,99,24"/>
</map>
 </div></div>

<p><a href="structiPcNewCamera-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#aa0df564424e41b7a1cba482cf3fd8c0e">AttachCameraMode</a> (iCelCameraMode *mode)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Attaches a camera mode to this camera.  <a href="#aa0df564424e41b7a1cba482cf3fd8c0e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a7f4d054a1273a039776a1e896e5242eb">AttachCameraMode</a> (CEL_CAMERA_MODE modetype)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Attaches a built-in camera mode to this camera.  <a href="#a7f4d054a1273a039776a1e896e5242eb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a1ecf6110cb5969b50ead9ea468558cd3">DetectCollisions</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the camera will use collision detection to avoid moving through walls.  <a href="#a1ecf6110cb5969b50ead9ea468558cd3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a6606a8da72c7af93984b4fa974c5ad18">Draw</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Render.  <a href="#a6606a8da72c7af93984b4fa974c5ad18"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a1af9a0c4a460d1781a070d0d35806165">GetBaseDir</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the base direction of the camera.  <a href="#a1af9a0c4a460d1781a070d0d35806165"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a3c6c26de11441455eb6614809100ab94">GetBaseOrigin</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the base origin of the camera in world coordinates.  <a href="#a3c6c26de11441455eb6614809100ab94"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a630158c8800e06ebf969fce45b20822a">GetBasePos</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the base position of the camera in world coordinates.  <a href="#a630158c8800e06ebf969fce45b20822a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <br class="typebreak"/>
<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a40bb9f23b883c4f82bbd43d476963304">GetBaseTrans</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the base transform of the camera.  <a href="#a40bb9f23b883c4f82bbd43d476963304"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ac9241773e13bfdb33e1bd3f74bf85615">GetBaseUp</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the base up vector of the camera.  <a href="#ac9241773e13bfdb33e1bd3f74bf85615"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual iCelCameraMode *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a813867df8e40e6cd1fd86800bcdf0aa0">GetCameraMode</a> (int idx=-1)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the specified camera mode.  <a href="#a813867df8e40e6cd1fd86800bcdf0aa0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a07c9b66a6fbb4a448191c001317245d6">GetCollisionAvoidanceInterpolation</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the collision avoidance movement interpolation value.  <a href="#a07c9b66a6fbb4a448191c001317245d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a14827eff0353d9c001d3d48cdf8b1d49">GetCollisionAvoidanceRadiusSq</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the player collision avoidance radius.  <a href="#a14827eff0353d9c001d3d48cdf8b1d49"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a2cb5951491b979d02687163e60d28f47">GetCollisionCorrection</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get collision correction multiplier...  <a href="#a2cb5951491b979d02687163e60d28f47"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a34894a8abad12faa7be0783b230f1996">GetCollisionDetection</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the camera will use collision detection to avoid moving through walls.  <a href="#a34894a8abad12faa7be0783b230f1996"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#aa482e4b15174c03a316148d07aa3f699">GetCollisionSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the spring coefficient that is used when a collision is detection.  <a href="#aa482e4b15174c03a316148d07aa3f699"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a9df168f220740b03e5c004398d1f76af">GetCollisionYAvoidance</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Y offset avoidance value.  <a href="#a9df168f220740b03e5c004398d1f76af"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#abb8c1e763a4e647e3c2485a5435507a5">GetCollisionYFocusOffset</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the y focus offset used in collision detection.  <a href="#abb8c1e763a4e647e3c2485a5435507a5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual iCelCameraMode *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a0670deb442ded4f73935bd8021cda342">GetCurrentCameraMode</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the current camera mode.  <a href="#a0670deb442ded4f73935bd8021cda342"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a2b6ac4c12fa4d7429dd75ce1a8266260">GetCurrentCameraModeIndex</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the index of the current camera mode.  <a href="#a2b6ac4c12fa4d7429dd75ce1a8266260"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a3ef8b29f580ba0c167794022ee420ad1">GetOrigin</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the current origin of the camera.  <a href="#a3ef8b29f580ba0c167794022ee420ad1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a957d4eb36ac20c5b64cf6c418212036e">GetOriginSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the origin spring coefficient that will be used for attached camera mode.  <a href="#a957d4eb36ac20c5b64cf6c418212036e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ad825a452433d9a47384633114fbaf5e0">GetPos</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the current position of the camera.  <a href="#ad825a452433d9a47384633114fbaf5e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ae6ac3cbf6ccb0db1651028ddaa344d0d">GetSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the common spring coefficient that will be used for attached camera mode.  <a href="#ae6ac3cbf6ccb0db1651028ddaa344d0d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#acdbd2379316db3c5e891f8d6d4805a19">GetTarget</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the current target of the camera.  <a href="#acdbd2379316db3c5e891f8d6d4805a19"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a1274e2782190ba95d385151a45054a60">GetTargetSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the target spring coefficient that will be used for attached camera mode.  <a href="#a1274e2782190ba95d385151a45054a60"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOrthoTransform.html">csOrthoTransform</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a22fb85b72f01ff79cc69007119ef8490">GetTransform</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the transform corresponding to this camera.  <a href="#a22fb85b72f01ff79cc69007119ef8490"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a06f696664f9137f199b218875cd071ea">GetTransitionCutoffOriginDistance</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Grabs the camera transition cutoff distance from origin to origin between the camera and the camera mode.  <a href="#a06f696664f9137f199b218875cd071ea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#afbf821620be2209fae7342e489a266a6">GetTransitionCutoffPosDistance</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Grabs the camera transition cutoff distance from position to position between the camera and the camera mode.  <a href="#afbf821620be2209fae7342e489a266a6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ab4d30909bbf6d9129b48951fa983c14a">GetTransitionCutoffTargetDistance</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Grabs the camera transition cutoff distance from target to target between the camera and the camera mode.  <a href="#ab4d30909bbf6d9129b48951fa983c14a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a39afc5f96614368c74480b335ffd6ebf">GetTransitionSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This gets the springyness of the transition to a new camera mode when a new camera mode is selected.  <a href="#a39afc5f96614368c74480b335ffd6ebf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#abff38634e9482b01de7855ed3ab61771">GetTransitionTime</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the time to transition to a new mode.  <a href="#abff38634e9482b01de7855ed3ab61771"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a7cb690a10297d3d15b52c495fe03b94c">GetUp</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the current up vector of the camera.  <a href="#a7cb690a10297d3d15b52c495fe03b94c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a715bae5190e2ac85e4c941097ac1f5c7">GetUpSpringCoefficient</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the up vector spring coefficient that will be used for attached camera mode.  <a href="#a715bae5190e2ac85e4c941097ac1f5c7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a3a52b2b2bbf6da5101a03c41f9b32076">InCameraTransition</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines whether the camera is currently in a transition from one camera mode to another.  <a href="#a3a52b2b2bbf6da5101a03c41f9b32076"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a943b936d459ee16d1b94b7d46745f4eb">NextCameraMode</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the current camera mode to the next available mode.  <a href="#a943b936d459ee16d1b94b7d46745f4eb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a52765a114a0a0f671a19c6d3b35d7729">PrevCameraMode</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the current camera mode to the previous available mode.  <a href="#a52765a114a0a0f671a19c6d3b35d7729"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; T &gt;&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a9b32042ddfc5ba593bb02bc4203fd2d3">QueryModeInterface</a> (int idx=-1)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the camera mode's specialised interface.  <a href="#a9b32042ddfc5ba593bb02bc4203fd2d3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#aabd701d15f17be60c7fb8442b8531800">Reset</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset the camera position.  <a href="#aabd701d15f17be60c7fb8442b8531800"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a06e58c03322deb1081d8f8fb28fc9a27">SetCameraPositionOffset</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;offset)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> to the position of the camera.  <a href="#a06e58c03322deb1081d8f8fb28fc9a27"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#af3784fb682300728ae2ddc05273991e4">SetCollisionAvoidanceInterpolation</a> (float aint)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the interpolation used in the collision avoidance.  <a href="#af3784fb682300728ae2ddc05273991e4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ae2a006804b18791cefacb358ef4296e3">SetCollisionAvoidanceRadiusSq</a> (float radsq)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the player collision avoidance radius.  <a href="#ae2a006804b18791cefacb358ef4296e3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a1fd85f053c5805d742224bdd1617f3a8">SetCollisionCorrection</a> (float corr)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">multiplier for projected beam used in collision detection to place camera.  <a href="#a1fd85f053c5805d742224bdd1617f3a8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a9e5dc22962c0cf4fb801c14db7173960">SetCollisionDetection</a> (bool detectCollisions)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets whether the camera will use collision detection to avoid moving through walls.  <a href="#a9e5dc22962c0cf4fb801c14db7173960"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ad7307143efe9064a91f2432471e0263b">SetCollisionSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the spring coefficient that will be used when a collision is detected.  <a href="#ad7307143efe9064a91f2432471e0263b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ab2de3d3e88b2a5575922643c7f246885">SetCollisionYAvoidance</a> (float yavoid)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the y offset for camera to move upwards by for avoidance when it comes too close.  <a href="#ab2de3d3e88b2a5575922643c7f246885"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a001f3844ab7dcb6a9022376419ec1746">SetCollisionYFocusOffset</a> (float yoff)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the y offset from player position for collision detection focus.  <a href="#a001f3844ab7dcb6a9022376419ec1746"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a961145734074a0695ca120390b6145b5">SetCurrentCameraMode</a> (size_t modeIndex)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the current camera mode.  <a href="#a961145734074a0695ca120390b6145b5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ad59cfdb4e58b0fb8c26816a5c4feb378">SetOriginSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the origin spring coefficient that will be used for attached camera mode.  <a href="#ad59cfdb4e58b0fb8c26816a5c4feb378"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#adaf1e44481d8ee79fc2decb9fdee3a30">SetPositionOffset</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;offset)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> (deprecated).  <a href="#adaf1e44481d8ee79fc2decb9fdee3a30"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a16e6dd536e977364522107d41bb2f65d">SetSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the common spring coefficient that will be used for attached camera mode.  <a href="#a16e6dd536e977364522107d41bb2f65d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ab7136f90aaf94bea49d88c22b1d4989e">SetTargetMinimumOffset</a> (float minoff)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the minimum allowed offset up until the target.  <a href="#ab7136f90aaf94bea49d88c22b1d4989e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#ad8ddb34c505409b726711b362a56297f">SetTargetPositionOffset</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;offset)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> to the position of the camera.  <a href="#ad8ddb34c505409b726711b362a56297f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#a7763e080053aead3ebb3ac1f47af794d">SetTargetSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the target spring coefficient that will be used for attached camera mode.  <a href="#a7763e080053aead3ebb3ac1f47af794d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#adde380bd6f7a4c25621a9eba40ecdb38">SetTransitionCutoffDistance</a> (float cutOffOriginDist, float cutOffTargetDist)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If the distance between the current camera position and the new camera mode is within this cutoff distance, then the camera will cease to be in a transition and be in the new camera mode.  <a href="#adde380bd6f7a4c25621a9eba40ecdb38"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#afd9d916f3009e84c849072bb4630f8ab">SetTransitionSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This controls the springyness of the transition to a new camera mode when a new camera mode is selected.  <a href="#afd9d916f3009e84c849072bb4630f8ab"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#abc58148144d91475d08ba9cdcc27aab3">SetTransitionTime</a> (float time)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the time to perform a transition.  <a href="#abc58148144d91475d08ba9cdcc27aab3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcNewCamera.html#aa587dc1874a7d4a7aab5c7c14f7511f1">SetUpSpringCoefficient</a> (float springCoef)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the up vector spring coefficient that will be used for attached camera mode.  <a href="#aa587dc1874a7d4a7aab5c7c14f7511f1"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a camera property class. </p>

<p>Definition at line <a class="el" href="newcamera_8h_source.html#l00262">262</a> of file <a class="el" href="newcamera_8h_source.html">newcamera.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aa0df564424e41b7a1cba482cf3fd8c0e"></a><!-- doxytag: member="iPcNewCamera::AttachCameraMode" ref="aa0df564424e41b7a1cba482cf3fd8c0e" args="(iCelCameraMode *mode)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiPcNewCamera.html#aa0df564424e41b7a1cba482cf3fd8c0e">iPcNewCamera::AttachCameraMode</a> </td>
          <td>(</td>
          <td class="paramtype">iCelCameraMode *&#160;</td>
          <td class="paramname"><em>mode</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Attaches a camera mode to this camera. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mode</td><td>The camera mode to attach. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A unique id for the attached camera mode. </dd></dl>

</div>
</div>
<a class="anchor" id="a7f4d054a1273a039776a1e896e5242eb"></a><!-- doxytag: member="iPcNewCamera::AttachCameraMode" ref="a7f4d054a1273a039776a1e896e5242eb" args="(CEL_CAMERA_MODE modetype)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiPcNewCamera.html#aa0df564424e41b7a1cba482cf3fd8c0e">iPcNewCamera::AttachCameraMode</a> </td>
          <td>(</td>
          <td class="paramtype">CEL_CAMERA_MODE&#160;</td>
          <td class="paramname"><em>modetype</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Attaches a built-in camera mode to this camera. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">mode</td><td>The id of the built-in camera mode to attach. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A unique id for the attached camera mode. </dd></dl>

</div>
</div>
<a class="anchor" id="a1ecf6110cb5969b50ead9ea468558cd3"></a><!-- doxytag: member="iPcNewCamera::DetectCollisions" ref="a1ecf6110cb5969b50ead9ea468558cd3" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNewCamera.html#a1ecf6110cb5969b50ead9ea468558cd3">iPcNewCamera::DetectCollisions</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the camera will use collision detection to avoid moving through walls. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>True if collision detection is enabled. </dd></dl>

</div>
</div>
<a class="anchor" id="a6606a8da72c7af93984b4fa974c5ad18"></a><!-- doxytag: member="iPcNewCamera::Draw" ref="a6606a8da72c7af93984b4fa974c5ad18" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a6606a8da72c7af93984b4fa974c5ad18">iPcNewCamera::Draw</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Render. </p>
<p>This will clear the screen then draw on top of it. </p>

<p>Implements <a class="el" href="structiPcCamera.html#af8f854a9ed62fa704a00cbabfa5e8539">iPcCamera</a>.</p>

</div>
</div>
<a class="anchor" id="a1af9a0c4a460d1781a070d0d35806165"></a><!-- doxytag: member="iPcNewCamera::GetBaseDir" ref="a1af9a0c4a460d1781a070d0d35806165" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#a1af9a0c4a460d1781a070d0d35806165">iPcNewCamera::GetBaseDir</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the base direction of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The base direction of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="a3c6c26de11441455eb6614809100ab94"></a><!-- doxytag: member="iPcNewCamera::GetBaseOrigin" ref="a3c6c26de11441455eb6614809100ab94" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#a3c6c26de11441455eb6614809100ab94">iPcNewCamera::GetBaseOrigin</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the base origin of the camera in world coordinates. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The base origin of the camera in world coordinates. </dd></dl>

</div>
</div>
<a class="anchor" id="a630158c8800e06ebf969fce45b20822a"></a><!-- doxytag: member="iPcNewCamera::GetBasePos" ref="a630158c8800e06ebf969fce45b20822a" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#a630158c8800e06ebf969fce45b20822a">iPcNewCamera::GetBasePos</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the base position of the camera in world coordinates. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The base position of the camera in world coordinates. </dd></dl>

</div>
</div>
<a class="anchor" id="a40bb9f23b883c4f82bbd43d476963304"></a><!-- doxytag: member="iPcNewCamera::GetBaseTrans" ref="a40bb9f23b883c4f82bbd43d476963304" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsReversibleTransform.html">csReversibleTransform</a>&amp; <a class="el" href="structiPcNewCamera.html#a40bb9f23b883c4f82bbd43d476963304">iPcNewCamera::GetBaseTrans</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the base transform of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The base transform of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="ac9241773e13bfdb33e1bd3f74bf85615"></a><!-- doxytag: member="iPcNewCamera::GetBaseUp" ref="ac9241773e13bfdb33e1bd3f74bf85615" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#ac9241773e13bfdb33e1bd3f74bf85615">iPcNewCamera::GetBaseUp</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the base up vector of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The base up vector of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="a813867df8e40e6cd1fd86800bcdf0aa0"></a><!-- doxytag: member="iPcNewCamera::GetCameraMode" ref="a813867df8e40e6cd1fd86800bcdf0aa0" args="(int idx=&#45;1)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual iCelCameraMode* <a class="el" href="structiPcNewCamera.html#a813867df8e40e6cd1fd86800bcdf0aa0">iPcNewCamera::GetCameraMode</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>idx</em> = <code>-1</code></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the specified camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">idx</td><td>If -1 it will return the current mode </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current camera mode. </dd></dl>

</div>
</div>
<a class="anchor" id="a07c9b66a6fbb4a448191c001317245d6"></a><!-- doxytag: member="iPcNewCamera::GetCollisionAvoidanceInterpolation" ref="a07c9b66a6fbb4a448191c001317245d6" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a07c9b66a6fbb4a448191c001317245d6">iPcNewCamera::GetCollisionAvoidanceInterpolation</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the collision avoidance movement interpolation value. </p>

</div>
</div>
<a class="anchor" id="a14827eff0353d9c001d3d48cdf8b1d49"></a><!-- doxytag: member="iPcNewCamera::GetCollisionAvoidanceRadiusSq" ref="a14827eff0353d9c001d3d48cdf8b1d49" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a14827eff0353d9c001d3d48cdf8b1d49">iPcNewCamera::GetCollisionAvoidanceRadiusSq</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the player collision avoidance radius. </p>

</div>
</div>
<a class="anchor" id="a2cb5951491b979d02687163e60d28f47"></a><!-- doxytag: member="iPcNewCamera::GetCollisionCorrection" ref="a2cb5951491b979d02687163e60d28f47" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a2cb5951491b979d02687163e60d28f47">iPcNewCamera::GetCollisionCorrection</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get collision correction multiplier... </p>
<p>returns a float. is const / woo! </p>

</div>
</div>
<a class="anchor" id="a34894a8abad12faa7be0783b230f1996"></a><!-- doxytag: member="iPcNewCamera::GetCollisionDetection" ref="a34894a8abad12faa7be0783b230f1996" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNewCamera.html#a34894a8abad12faa7be0783b230f1996">iPcNewCamera::GetCollisionDetection</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the camera will use collision detection to avoid moving through walls. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>True if collision detection is enabled. </dd></dl>

</div>
</div>
<a class="anchor" id="aa482e4b15174c03a316148d07aa3f699"></a><!-- doxytag: member="iPcNewCamera::GetCollisionSpringCoefficient" ref="aa482e4b15174c03a316148d07aa3f699" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#aa482e4b15174c03a316148d07aa3f699">iPcNewCamera::GetCollisionSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the spring coefficient that is used when a collision is detection. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The collision detection spring coefficient. </dd></dl>

</div>
</div>
<a class="anchor" id="a9df168f220740b03e5c004398d1f76af"></a><!-- doxytag: member="iPcNewCamera::GetCollisionYAvoidance" ref="a9df168f220740b03e5c004398d1f76af" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a9df168f220740b03e5c004398d1f76af">iPcNewCamera::GetCollisionYAvoidance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the Y offset avoidance value. </p>

</div>
</div>
<a class="anchor" id="abb8c1e763a4e647e3c2485a5435507a5"></a><!-- doxytag: member="iPcNewCamera::GetCollisionYFocusOffset" ref="abb8c1e763a4e647e3c2485a5435507a5" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#abb8c1e763a4e647e3c2485a5435507a5">iPcNewCamera::GetCollisionYFocusOffset</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the y focus offset used in collision detection. </p>

</div>
</div>
<a class="anchor" id="a0670deb442ded4f73935bd8021cda342"></a><!-- doxytag: member="iPcNewCamera::GetCurrentCameraMode" ref="a0670deb442ded4f73935bd8021cda342" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual iCelCameraMode* <a class="el" href="structiPcNewCamera.html#a0670deb442ded4f73935bd8021cda342">iPcNewCamera::GetCurrentCameraMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the current camera mode. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current camera mode. </dd></dl>

</div>
</div>
<a class="anchor" id="a2b6ac4c12fa4d7429dd75ce1a8266260"></a><!-- doxytag: member="iPcNewCamera::GetCurrentCameraModeIndex" ref="a2b6ac4c12fa4d7429dd75ce1a8266260" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t <a class="el" href="structiPcNewCamera.html#a2b6ac4c12fa4d7429dd75ce1a8266260">iPcNewCamera::GetCurrentCameraModeIndex</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the index of the current camera mode. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The index of the current camera mode. </dd></dl>

</div>
</div>
<a class="anchor" id="a3ef8b29f580ba0c167794022ee420ad1"></a><!-- doxytag: member="iPcNewCamera::GetOrigin" ref="a3ef8b29f580ba0c167794022ee420ad1" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#a3ef8b29f580ba0c167794022ee420ad1">iPcNewCamera::GetOrigin</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the current origin of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current origin of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="a957d4eb36ac20c5b64cf6c418212036e"></a><!-- doxytag: member="iPcNewCamera::GetOriginSpringCoefficient" ref="a957d4eb36ac20c5b64cf6c418212036e" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a957d4eb36ac20c5b64cf6c418212036e">iPcNewCamera::GetOriginSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the origin spring coefficient that will be used for attached camera mode. </p>

</div>
</div>
<a class="anchor" id="ad825a452433d9a47384633114fbaf5e0"></a><!-- doxytag: member="iPcNewCamera::GetPos" ref="ad825a452433d9a47384633114fbaf5e0" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#ad825a452433d9a47384633114fbaf5e0">iPcNewCamera::GetPos</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the current position of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current position of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="ae6ac3cbf6ccb0db1651028ddaa344d0d"></a><!-- doxytag: member="iPcNewCamera::GetSpringCoefficient" ref="ae6ac3cbf6ccb0db1651028ddaa344d0d" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#ae6ac3cbf6ccb0db1651028ddaa344d0d">iPcNewCamera::GetSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the common spring coefficient that will be used for attached camera mode. </p>

</div>
</div>
<a class="anchor" id="acdbd2379316db3c5e891f8d6d4805a19"></a><!-- doxytag: member="iPcNewCamera::GetTarget" ref="acdbd2379316db3c5e891f8d6d4805a19" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#acdbd2379316db3c5e891f8d6d4805a19">iPcNewCamera::GetTarget</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the current target of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current target of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="a1274e2782190ba95d385151a45054a60"></a><!-- doxytag: member="iPcNewCamera::GetTargetSpringCoefficient" ref="a1274e2782190ba95d385151a45054a60" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a1274e2782190ba95d385151a45054a60">iPcNewCamera::GetTargetSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the target spring coefficient that will be used for attached camera mode. </p>

</div>
</div>
<a class="anchor" id="a22fb85b72f01ff79cc69007119ef8490"></a><!-- doxytag: member="iPcNewCamera::GetTransform" ref="a22fb85b72f01ff79cc69007119ef8490" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsOrthoTransform.html">csOrthoTransform</a>&amp; <a class="el" href="structiPcNewCamera.html#a22fb85b72f01ff79cc69007119ef8490">iPcNewCamera::GetTransform</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the transform corresponding to this camera. </p>
<p>In this transform, 'other' is world space and 'this' is camera space. </p>

</div>
</div>
<a class="anchor" id="a06f696664f9137f199b218875cd071ea"></a><!-- doxytag: member="iPcNewCamera::GetTransitionCutoffOriginDistance" ref="a06f696664f9137f199b218875cd071ea" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a06f696664f9137f199b218875cd071ea">iPcNewCamera::GetTransitionCutoffOriginDistance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Grabs the camera transition cutoff distance from origin to origin between the camera and the camera mode. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The camera transition cutoff distance from target to target. </dd></dl>

</div>
</div>
<a class="anchor" id="afbf821620be2209fae7342e489a266a6"></a><!-- doxytag: member="iPcNewCamera::GetTransitionCutoffPosDistance" ref="afbf821620be2209fae7342e489a266a6" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#afbf821620be2209fae7342e489a266a6">iPcNewCamera::GetTransitionCutoffPosDistance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Grabs the camera transition cutoff distance from position to position between the camera and the camera mode. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The camera transition cutoff distance from target to target. </dd></dl>

</div>
</div>
<a class="anchor" id="ab4d30909bbf6d9129b48951fa983c14a"></a><!-- doxytag: member="iPcNewCamera::GetTransitionCutoffTargetDistance" ref="ab4d30909bbf6d9129b48951fa983c14a" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#ab4d30909bbf6d9129b48951fa983c14a">iPcNewCamera::GetTransitionCutoffTargetDistance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Grabs the camera transition cutoff distance from target to target between the camera and the camera mode. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The camera transition cutoff distance from position to position. </dd></dl>

</div>
</div>
<a class="anchor" id="a39afc5f96614368c74480b335ffd6ebf"></a><!-- doxytag: member="iPcNewCamera::GetTransitionSpringCoefficient" ref="a39afc5f96614368c74480b335ffd6ebf" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a39afc5f96614368c74480b335ffd6ebf">iPcNewCamera::GetTransitionSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This gets the springyness of the transition to a new camera mode when a new camera mode is selected. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The spring coefficient of the camera transitions. </dd></dl>

</div>
</div>
<a class="anchor" id="abff38634e9482b01de7855ed3ab61771"></a><!-- doxytag: member="iPcNewCamera::GetTransitionTime" ref="abff38634e9482b01de7855ed3ab61771" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#abff38634e9482b01de7855ed3ab61771">iPcNewCamera::GetTransitionTime</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the time to transition to a new mode. </p>

</div>
</div>
<a class="anchor" id="a7cb690a10297d3d15b52c495fe03b94c"></a><!-- doxytag: member="iPcNewCamera::GetUp" ref="a7cb690a10297d3d15b52c495fe03b94c" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="el" href="structiPcNewCamera.html#a7cb690a10297d3d15b52c495fe03b94c">iPcNewCamera::GetUp</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the current up vector of the camera. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current up vector of the camera. </dd></dl>

</div>
</div>
<a class="anchor" id="a715bae5190e2ac85e4c941097ac1f5c7"></a><!-- doxytag: member="iPcNewCamera::GetUpSpringCoefficient" ref="a715bae5190e2ac85e4c941097ac1f5c7" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcNewCamera.html#a715bae5190e2ac85e4c941097ac1f5c7">iPcNewCamera::GetUpSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the up vector spring coefficient that will be used for attached camera mode. </p>

</div>
</div>
<a class="anchor" id="a3a52b2b2bbf6da5101a03c41f9b32076"></a><!-- doxytag: member="iPcNewCamera::InCameraTransition" ref="a3a52b2b2bbf6da5101a03c41f9b32076" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNewCamera.html#a3a52b2b2bbf6da5101a03c41f9b32076">iPcNewCamera::InCameraTransition</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines whether the camera is currently in a transition from one camera mode to another. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>True if the camera is currently in a transition. </dd></dl>

</div>
</div>
<a class="anchor" id="a943b936d459ee16d1b94b7d46745f4eb"></a><!-- doxytag: member="iPcNewCamera::NextCameraMode" ref="a943b936d459ee16d1b94b7d46745f4eb" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a943b936d459ee16d1b94b7d46745f4eb">iPcNewCamera::NextCameraMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the current camera mode to the next available mode. </p>

</div>
</div>
<a class="anchor" id="a52765a114a0a0f671a19c6d3b35d7729"></a><!-- doxytag: member="iPcNewCamera::PrevCameraMode" ref="a52765a114a0a0f671a19c6d3b35d7729" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a52765a114a0a0f671a19c6d3b35d7729">iPcNewCamera::PrevCameraMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the current camera mode to the previous available mode. </p>

</div>
</div>
<a class="anchor" id="a9b32042ddfc5ba593bb02bc4203fd2d3"></a><!-- doxytag: member="iPcNewCamera::QueryModeInterface" ref="a9b32042ddfc5ba593bb02bc4203fd2d3" args="(int idx=&#45;1)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;T&gt; <a class="el" href="structiPcNewCamera.html#a9b32042ddfc5ba593bb02bc4203fd2d3">iPcNewCamera::QueryModeInterface</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>idx</em> = <code>-1</code></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the camera mode's specialised interface. </p>
<p>If the specified mode does not implement that interface will return null. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">T</td><td>Template parameter for camera interface </td></tr>
    <tr><td class="paramname">idx</td><td>If -1 it will return the current mode </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The current camera mode's interface. </dd></dl>

<p>Definition at line <a class="el" href="newcamera_8h_source.html#l00649">649</a> of file <a class="el" href="newcamera_8h_source.html">newcamera.h</a>.</p>

</div>
</div>
<a class="anchor" id="aabd701d15f17be60c7fb8442b8531800"></a><!-- doxytag: member="iPcNewCamera::Reset" ref="aabd701d15f17be60c7fb8442b8531800" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNewCamera.html#aabd701d15f17be60c7fb8442b8531800">iPcNewCamera::Reset</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reset the camera position. </p>

</div>
</div>
<a class="anchor" id="a06e58c03322deb1081d8f8fb28fc9a27"></a><!-- doxytag: member="iPcNewCamera::SetCameraPositionOffset" ref="a06e58c03322deb1081d8f8fb28fc9a27" args="(const csVector3 &amp;offset)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a06e58c03322deb1081d8f8fb28fc9a27">iPcNewCamera::SetCameraPositionOffset</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>offset</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> to the position of the camera. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">offset</td><td>the offset from the center of the mesh to the camera position. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af3784fb682300728ae2ddc05273991e4"></a><!-- doxytag: member="iPcNewCamera::SetCollisionAvoidanceInterpolation" ref="af3784fb682300728ae2ddc05273991e4" args="(float aint)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#af3784fb682300728ae2ddc05273991e4">iPcNewCamera::SetCollisionAvoidanceInterpolation</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>aint</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the interpolation used in the collision avoidance. </p>
<p>Hard to describe how the value works but values close to 0 will give a fast jump, 1.0 is more realistic but higher is nicer and slower. </p>

</div>
</div>
<a class="anchor" id="ae2a006804b18791cefacb358ef4296e3"></a><!-- doxytag: member="iPcNewCamera::SetCollisionAvoidanceRadiusSq" ref="ae2a006804b18791cefacb358ef4296e3" args="(float radsq)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ae2a006804b18791cefacb358ef4296e3">iPcNewCamera::SetCollisionAvoidanceRadiusSq</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>radsq</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the player collision avoidance radius. </p>
<p>Moves up over the player when camera gets too close. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">radsq</td><td>The squared radius value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1fd85f053c5805d742224bdd1617f3a8"></a><!-- doxytag: member="iPcNewCamera::SetCollisionCorrection" ref="a1fd85f053c5805d742224bdd1617f3a8" args="(float corr)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a1fd85f053c5805d742224bdd1617f3a8">iPcNewCamera::SetCollisionCorrection</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>corr</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>multiplier for projected beam used in collision detection to place camera. </p>
<p>Values greater than 1.0f are desireable but project the camera position further away from it's true point the larger it is. A value of about 1.5f is usually good and is set as default anyway. 1.0f will give the true collision intersection of the camera, but you might end up seeing through walls ;) </p>

</div>
</div>
<a class="anchor" id="a9e5dc22962c0cf4fb801c14db7173960"></a><!-- doxytag: member="iPcNewCamera::SetCollisionDetection" ref="a9e5dc22962c0cf4fb801c14db7173960" args="(bool detectCollisions)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a9e5dc22962c0cf4fb801c14db7173960">iPcNewCamera::SetCollisionDetection</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>detectCollisions</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets whether the camera will use collision detection to avoid moving through walls. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">detectCollisions</td><td>True if the camera should detect collisions. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad7307143efe9064a91f2432471e0263b"></a><!-- doxytag: member="iPcNewCamera::SetCollisionSpringCoefficient" ref="ad7307143efe9064a91f2432471e0263b" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ad7307143efe9064a91f2432471e0263b">iPcNewCamera::SetCollisionSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the spring coefficient that will be used when a collision is detected. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab2de3d3e88b2a5575922643c7f246885"></a><!-- doxytag: member="iPcNewCamera::SetCollisionYAvoidance" ref="ab2de3d3e88b2a5575922643c7f246885" args="(float yavoid)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ab2de3d3e88b2a5575922643c7f246885">iPcNewCamera::SetCollisionYAvoidance</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>yavoid</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the y offset for camera to move upwards by for avoidance when it comes too close. </p>

</div>
</div>
<a class="anchor" id="a001f3844ab7dcb6a9022376419ec1746"></a><!-- doxytag: member="iPcNewCamera::SetCollisionYFocusOffset" ref="a001f3844ab7dcb6a9022376419ec1746" args="(float yoff)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a001f3844ab7dcb6a9022376419ec1746">iPcNewCamera::SetCollisionYFocusOffset</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>yoff</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the y offset from player position for collision detection focus. </p>

</div>
</div>
<a class="anchor" id="a961145734074a0695ca120390b6145b5"></a><!-- doxytag: member="iPcNewCamera::SetCurrentCameraMode" ref="a961145734074a0695ca120390b6145b5" args="(size_t modeIndex)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcNewCamera.html#a961145734074a0695ca120390b6145b5">iPcNewCamera::SetCurrentCameraMode</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>modeIndex</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the current camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">modeIndex</td><td>The index of the current camera mode. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>True on successful camera mode change. </dd></dl>

</div>
</div>
<a class="anchor" id="ad59cfdb4e58b0fb8c26816a5c4feb378"></a><!-- doxytag: member="iPcNewCamera::SetOriginSpringCoefficient" ref="ad59cfdb4e58b0fb8c26816a5c4feb378" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ad59cfdb4e58b0fb8c26816a5c4feb378">iPcNewCamera::SetOriginSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the origin spring coefficient that will be used for attached camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adaf1e44481d8ee79fc2decb9fdee3a30"></a><!-- doxytag: member="iPcNewCamera::SetPositionOffset" ref="adaf1e44481d8ee79fc2decb9fdee3a30" args="(const csVector3 &amp;offset)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#adaf1e44481d8ee79fc2decb9fdee3a30">iPcNewCamera::SetPositionOffset</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>offset</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> (deprecated). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">offset</td><td>the offset from the center of the mesh </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a16e6dd536e977364522107d41bb2f65d"></a><!-- doxytag: member="iPcNewCamera::SetSpringCoefficient" ref="a16e6dd536e977364522107d41bb2f65d" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a16e6dd536e977364522107d41bb2f65d">iPcNewCamera::SetSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the common spring coefficient that will be used for attached camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab7136f90aaf94bea49d88c22b1d4989e"></a><!-- doxytag: member="iPcNewCamera::SetTargetMinimumOffset" ref="ab7136f90aaf94bea49d88c22b1d4989e" args="(float minoff)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ab7136f90aaf94bea49d88c22b1d4989e">iPcNewCamera::SetTargetMinimumOffset</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minoff</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the minimum allowed offset up until the target. </p>

</div>
</div>
<a class="anchor" id="ad8ddb34c505409b726711b362a56297f"></a><!-- doxytag: member="iPcNewCamera::SetTargetPositionOffset" ref="ad8ddb34c505409b726711b362a56297f" args="(const csVector3 &amp;offset)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#ad8ddb34c505409b726711b362a56297f">iPcNewCamera::SetTargetPositionOffset</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>offset</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the offset from the center of the mesh's <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiMovable.html">iMovable</a> to the position of the camera. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">offset</td><td>the offset from the center of the mesh to the camera position. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7763e080053aead3ebb3ac1f47af794d"></a><!-- doxytag: member="iPcNewCamera::SetTargetSpringCoefficient" ref="a7763e080053aead3ebb3ac1f47af794d" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#a7763e080053aead3ebb3ac1f47af794d">iPcNewCamera::SetTargetSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the target spring coefficient that will be used for attached camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adde380bd6f7a4c25621a9eba40ecdb38"></a><!-- doxytag: member="iPcNewCamera::SetTransitionCutoffDistance" ref="adde380bd6f7a4c25621a9eba40ecdb38" args="(float cutOffOriginDist, float cutOffTargetDist)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#adde380bd6f7a4c25621a9eba40ecdb38">iPcNewCamera::SetTransitionCutoffDistance</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>cutOffOriginDist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>cutOffTargetDist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If the distance between the current camera position and the new camera mode is within this cutoff distance, then the camera will cease to be in a transition and be in the new camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">cutOffOriginDist</td><td>The camera transition mode cutoff distance from origin to origin. </td></tr>
    <tr><td class="paramname">cutOffTargetDist</td><td>The camera transition mode cutoff distance from target to target. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afd9d916f3009e84c849072bb4630f8ab"></a><!-- doxytag: member="iPcNewCamera::SetTransitionSpringCoefficient" ref="afd9d916f3009e84c849072bb4630f8ab" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#afd9d916f3009e84c849072bb4630f8ab">iPcNewCamera::SetTransitionSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This controls the springyness of the transition to a new camera mode when a new camera mode is selected. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient of camera transitions. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abc58148144d91475d08ba9cdcc27aab3"></a><!-- doxytag: member="iPcNewCamera::SetTransitionTime" ref="abc58148144d91475d08ba9cdcc27aab3" args="(float time)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#abc58148144d91475d08ba9cdcc27aab3">iPcNewCamera::SetTransitionTime</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>time</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the time to perform a transition. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">time</td><td>Time to transition to the new mode. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa587dc1874a7d4a7aab5c7c14f7511f1"></a><!-- doxytag: member="iPcNewCamera::SetUpSpringCoefficient" ref="aa587dc1874a7d4a7aab5c7c14f7511f1" args="(float springCoef)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcNewCamera.html#aa587dc1874a7d4a7aab5c7c14f7511f1">iPcNewCamera::SetUpSpringCoefficient</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>springCoef</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the up vector spring coefficient that will be used for attached camera mode. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">springCoef</td><td>The new spring coefficient. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="newcamera_8h_source.html">newcamera.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
